#cython: language_level=3

'''
Created on 25 mars 2016

@author: coissac
'''

from obitools3.utils cimport __etag__
import re


__ret__  = re.compile('''(([^ ]+)=('[^']*'|"[^"]*"|[^;]+); *)+?''')


cpdef tuple parseHeader(str header):
    cdef list m 
    cdef dict tags 
    cdef str definition
    cdef str ident
    cdef str second
    
    m=header[1:-1].split(maxsplit=1)
   
    ident=m[0]
    if ident[-1] == ';':
        ident = ident[:-1]
    
    if len(m)==1:
        tags={}
        definition='' 
    else:
        second=m[1]
        m = __ret__.findall(second)
        
        if m:
            tags = dict([(a[1],__etag__(a[2])) for a in m])
            definition = second.split(m[-1][0],1)[1].strip()
        else:
            tags = {}
            definition = second.strip() 
        
    return ident,tags,definition
    

